' Gomoku - Five in a Row for the Color MaxiMite 2 computer
' Played on a 19 x 19 board
' Any five in a row wins, except that 6 in a row loses.
'
' Players take turns and may play on any unoccupied cell

' Direct vectors - these represent the 4 directions from
' the cell under consideration
OPTION DEFAULT INTEGER

Data 0,1,  1,1,  1,0,  1,-1

' Initial Board Values - a few points for staying closer to the center

Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
Data 0,0,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,0,0
Data 0,0,1,2,3,3,3,3,3,3,3,3,3,3,3,2,1,0,0
Data 0,0,1,2,3,4,4,4,4,4,4,4,4,4,3,2,1,0,0
Data 0,0,1,2,3,4,5,5,5,5,5,5,5,4,3,2,1,0,0
Data 0,0,1,2,3,4,5,6,6,6,6,6,5,4,3,2,1,0,0
Data 0,0,1,2,3,4,5,6,7,7,7,6,5,4,3,2,1,0,0
Data 0,0,1,2,3,4,5,6,7,8,7,6,5,4,3,2,1,0,0
Data 0,0,1,2,3,4,5,6,7,7,7,6,5,4,3,2,1,0,0
Data 0,0,1,2,3,4,5,6,6,6,6,6,5,4,3,2,1,0,0
Data 0,0,1,2,3,4,5,5,5,5,5,5,5,4,3,2,1,0,0
Data 0,0,1,2,3,4,4,4,4,4,4,4,4,4,3,2,1,0,0
Data 0,0,1,2,3,3,3,3,3,3,3,3,3,3,3,2,1,0,0
Data 0,0,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,0,0
Data 0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

' Scoring Tables
' Each row of 10 numbers represents the pieces to either side of
'  the cell under test. The missing number at the middle of each row
'  is taken to be empty and is the cell under consideration
'  5 cells to the left and right are examined. Each pattern is applied
'  in each of 4 directions
'
' On the playing board ("arena")
'  1 = empty; 2 = human piece; 4 = computer piece
'
' In the pattern table, if the pattern bitwise AND with piece
'  on the board is non-zero, then that is a pattern match.
'
'     1 = empty square             = empty
'     2 = enemy piece              = enemy
'     3 = anything except my piece = empty OR enemy
'     4 = my piece                 = me
'     5 = anything but enemy piece = empty OR me
'     7 = don't care               = empty OR enemy OR me
'
'     All patterns are tried in all directions from the current square
'     In the pattern comments,"O" is computer's piece, "X" is human's,
'     "+" is cell being scored, "." is empty, "=" is blocked
'
' These scores could probably be adjusted for stronger play
' plus, more patterns could probably be added for scoring as well


Data 7,7,7,7,3, 4,4,4,4,3,  6000 ' .+OOOO.
Data 7,7,7,3,4, 4,4,4,3,7,  6000 ' .O+OOO.
Data 7,7,3,4,4, 4,4,3,7,7,  6000 ' .OO+OO.
Data 7,3,4,4,4, 4,3,7,7,7,  6000 ' .OOO+O.
Data 3,4,4,4,4, 3,7,7,7,7,  6000 ' .OOOO+.

Data 7,7,7,7,5, 2,2,2,2,5,  4000 ' .+XXXX.
Data 7,7,7,5,2, 2,2,2,5,7,  4000 ' .X+XXX.
Data 7,7,5,2,2, 2,2,5,7,7,  4000 ' .XX+XX.
Data 7,5,2,2,2, 2,5,7,7,7,  4000 ' .XXX+X.
Data 5,2,2,2,2, 5,7,7,7,7,  4000 ' .XXXX+.

Data 3,4,4,4,1, 3,7,7,7,7,  2000 ' .OOO.+.
Data 7,7,7,7,3, 1,4,4,4,3,  2000 ' .+.OOO.
Data 7,3,4,4,1, 4,3,7,7,7,  2000 ' .OO.+O.
Data 7,7,7,3,4, 1,4,4,3,7,  2000 ' .O+.OO.

Data 7,7,7,3,1, 4,4,4,1,3,  3000 ' .+OOO.
Data 7,7,3,1,4, 4,4,1,3,7,  3000 ' .O+OO.
Data 7,3,1,4,4, 4,1,3,7,7,  3000 ' .OO+O.
Data 3,1,4,4,4, 1,3,7,7,7,  3000 ' .OOO+.

Data 7,7,7,5,1, 2,2,2,1,5,  2500 ' .+XXX.
Data 7,7,5,1,2, 2,2,1,5,7,  2500 ' .X+XX.
Data 7,5,1,2,2, 2,1,5,7,7,  2500 ' .XX+X.
Data 5,1,2,2,2, 1,5,7,7,7,  2500 ' .XXX+.

Data 7,7,7,3,1, 4,4,4,3,7,  1200 ' .+OOO=
Data 7,7,7,7,3, 4,4,4,1,3,  1200 ' =+OOO.
Data 7,7,3,1,4, 4,4,3,7,7,  1200 ' .O+OO=
Data 7,7,7,3,4, 4,4,1,3,7,  1200 ' =O+OO.
Data 7,3,1,4,4, 4,3,7,7,7,  1200 ' .OO+O=
Data 7,7,3,4,4, 4,1,3,7,7,  1200 ' =OO+O.

Data 7,7,7,5,1, 2,2,2,5,7,   900 ' .+XXX=
Data 7,7,7,7,5, 2,2,2,1,5,   900 ' =+XXX.
Data 7,7,5,1,2, 2,2,5,7,7,   900 ' .X+XX=
Data 7,7,7,5,2, 2,2,1,5,7,   900 ' =X+XX.
Data 7,5,1,2,2, 2,5,7,7,7,   900 ' .XX+X=
Data 7,7,5,2,2, 2,1,5,7,7,   900 ' =XX+X.

Data 7,7,3,1,1, 4,4,1,1,3,   700 ' ..+OO..
Data 7,7,3,1,4, 4,1,1,3,7,   700 ' ..O+O..
Data 7,7,3,4,4, 1,1,3,7,7,   700 ' ..OO+..

Data 7,7,5,1,1, 2,2,1,1,5,   500 ' ..+XX..
Data 7,7,5,1,2, 2,1,1,5,7,   500 ' ..X+X..
Data 7,7,5,2,2, 1,1,5,7,7,   500 ' ..XX+..

Data 7,7,3,4,1, 4,1,3,7,7,   600 ' .O.+O.
Data 7,7,3,1,4, 1,4,3,7,7,   600 ' .O+.O.

Data 7,7,5,2,1, 2,1,5,7,7,   500 ' .X.+X.
Data 7,7,5,1,2, 1,2,5,7,7,   500 ' .X+.X.

Data 7,7,4,4,1, 1,3,7,7,7,   600 ' .OO.+...
Data 7,7,7,3,1, 1,4,4,7,7,   600 ' ...+.OO.

Data 7,7,2,2,1, 1,5,7,7,7,   600 ' .XX.+...
Data 7,7,7,5,1, 1,2,2,7,7,   600 ' ...+.XX.

Data 7,7,4,1,4, 1,3,7,7,7,   600 ' .O.O+...
Data 7,7,7,3,1, 4,1,4,7,7,   600 ' ...+O.O.

Data 7,7,2,1,2, 1,5,7,7,7,   600 ' .XX.+...
Data 7,7,7,5,1, 2,1,2,7,7,   600 ' ...+.XX.

Data 7,7,3,1,4, 1,1,3,7,7,   450 ' ...O+...
Data 7,7,3,1,1, 4,1,3,7,7,   450 ' ...+O...

Data 7,7,5,1,2, 1,1,5,7,7,   350 ' ...X+...
Data 7,7,5,1,1, 2,1,5,7,7,   350 ' ...+X...

Data 7,7,3,4,1, 1,1,3,7,7,   250 ' ..O.+...
Data 7,7,3,1,1, 1,4,3,7,7,   250 ' ..+.O...

Data 7,7,5,2,1, 1,1,5,7,7,   150 ' ..X.+...
Data 7,7,5,1,1, 1,2,5,7,7,   150 ' ..+.X...


Data -1, -1 ' end of table


'--------------------------------------

' Game Logic

Dim pattern(10)
Dim vectors(3,1)
Dim DISP(4)
Dim wloc(10,1)
Dim winner(5,1)
DISP(0) = Asc("."): DISP(1) = Asc("@"): DISP(2) = Asc("*")
DISP(4) = Asc("#") ' temporary
Const EMPTY = 1
Const HUMAN = 2
Const COMPUTER = 4
' Global variables
gpx = 0
gpy = 0

' Load intial board configuration and scoring tables

Dim arena(18,18)        ' 19 x 19 playing field
Dim loc_score(18,18)    ' 19 x 19 positional scores
Dim scores_table(80,10) ' score value tables

mode 1,16
Load_Tables

'--------------------------------------

' MAIN

Do
   Color rgb(white),rgb(black)
   Start_Instructions
   ks$ = Inkey$ ' clear any previous keypresses
   do
     ks$ = Inkey$
   loop while asc(ks$)=0
   gplayer = 0
   if ks$ = "1" then gplayer = HUMAN
   if ks$ = "2" then gplayer = COMPUTER
   If gplayer = 0 Then End   ' exit game
   Initialize_Board
   load png "gomoku1.png"
   Play_Instructions
   Do

      If gplayer = HUMAN Then
         Get_Player_Move
      Else
         Get_Computer_Move
      EndIf
      Animate_Move gpx, gpy
      Set_Board gpx, gpy, gplayer
      game_over = Check_Winner( gpx, gpy )
      gplayer = 6-gplayer    ' 4 -> 2; 2 -> 4

   Loop Until game_over
   Color rgb(red)
   If game_over = -1 Then
      Text 620,300,"Oh No!"
      Text 620,315,"Six in a row"
      Display_Winner gplayer ' Other player loses with 6 in a row
   Else
      Text 620,300,"Five in a row"
      Display_Winner 6-gplayer ' OTHER player wins with 5 in a row
   EndIf
   Color rgb(white)
Loop

'--------------------------------------

Sub Start_Instructions

   Text 620,10, "   INSTRUCTIONS"
   Text 620,23, "___________________"
   Text 620,46, "To Start Game:     "
   Text 620,65, "1 to go first.     "
   Text 620,78, "2 to let computer  "
   Text 620,91, "   play first.     "
   Text 620,104,"                   "
   Text 620,117,"Hit 'Q' any time   "
   Text 620,130,"     to QUIT       "
   Text 620,200,"The object of the  "
   Text 620,213,"game is to get 5   "
   Text 620,226,"in a row. But if   "
   Text 620,239,"you get 6 in a row "
   Text 620,252,"you lose!          "


end sub


'--------------------------------------

Sub Play_Instructions

   Text 620,10, "   INSTRUCTIONS"
   Text 620,23, "___________________"
   Text 620,46, "To Play Game:      "
   Text 620,65, "Use Arrow Keys to  "
   Text 620,78, "   move cursor.    "
   Text 620,91, "Hit ENTER to select"
   Text 620,104,"   select move.    "
   Text 620,117,"Hit 'Q' any time   "
   Text 620,130,"     to QUIT.      "
   Text 620,200,"The object of the  "
   Text 620,213,"game is to get 5   "
   Text 620,226,"in a row. But if   "
   Text 620,239,"you get 6 in a row "
   Text 620,252,"you lose!          "

end sub

'--------------------------------------
Sub Load_Tables

   Initialize_Board
   li = 0
   Do
      Read lv
      If lv >= 0 Then
         scores_table( li, 0 ) = lv
         For lj = 1 To 10
            Read scores_table( li, lj )
         Next lj
         li = li + 1
      Else
         scores_table( li, 0 ) = -1
         Exit Do
      EndIf
   Loop

End Sub

'--------------------------------------

Sub Initialize_Board

   Restore: Cls
   For li = 0 To 3
      Read vectors( li, 0 )
      Read vectors( li, 1 )
   Next li


   For li = 0 To 18
      For lj = 0 To 18
         Read loc_score( li, lj )
      Next lj
   Next li

   For li = 0 To 18
      For lj = 0 To 18
         arena( li, lj ) = EMPTY
      Next lj
   Next li

'  Set up cursor sprite

   page write 1
   cls
   box 23,23,16,16,1,rgb(blue)
   sprite read 1,20,20,30,30
   page write 0


End Sub

'--------------------------------------

' Ask player for his move. Set globals gpx and gpy

Sub Get_Player_Move

   spx = 276
   spy = 276
   gpx = 9
   gpy = 9
   do
      Sprite Show 1,spx,spy,1
      do
         ks$ = Inkey$: mk = Asc( ks$ )
         dx = 0: dy = 0 : quit = 0
         if mk = 130 then dx = -1
         if mk = 131 then dx = 1
         if mk = 128 then dy = -1
         if mk = 129 then dy = 1
         if ks$ = "q" then end
         gpx = gpx + dx
         spx = spx + 28 * dx
         if gpx > 18 then
            gpx = 0
            spx = 24
         endif
         if gpx < 0 then
            gpx = 18
            spx = 528
         endif
         gpy = gpy + dy
         spy = spy + 28 * dy
         if gpy > 18 then
            gpy = 0
            spy = 24
         endif
         if gpy < 0 then
            gpy = 18
            spy = 528
         end if
      loop while mk = 0
   loop until mk = 13 And arena( gpx, gpy ) = 1
   Sprite Hide 1

End Sub

'--------------------------------------

' Compute score of all moves and pick the best one
' Set move as globals gpx and gpy

Sub Get_Computer_Move

   high_score = -1
   high_x = -1
   high_y = -1
   For cx = 0 To 18
      For cy = 0 To 18
         If arena( cx, cy ) = EMPTY Then
            ' Here if the cell is available to play in
            score = loc_score( cx, cy ) ' base value of the empty cell
            For dir = 0 To 3
               dx = vectors( dir, 0 )
               dy = vectors( dir, 1 )
               pieces = 0
               For dist = 1 To 5
                  dl = 5 - dist
                  dr = 4 + dist
                  xl = cx - dist * dx
                  yl = cy - dist * dy
                  xr = cx + dist * dx
                  yr = cy + dist * dy
                  If xl >= 0 And xl <= 18 And yl >= 0 And yl <= 18 Then
                     pattern( dl ) = arena( xl, yl )
                  Else
                     pattern( dl ) = EMPTY
                  EndIf
                  If xr >= 0 And xr <= 18 And yr >= 0 And yr <= 18 Then
                     pattern( dr ) = arena( xr, yr )
                  Else
                     pattern( dr ) = EMPTY
                  EndIf
                  pieces = pieces + pattern( dl ) + pattern( dr )
               Next dist

               ' Pattern has been collected. Now find it in the table
               If pieces > 10 Then
                  ' There is something other than just empty cells
                  cj = 0
                  Do
                     fail = 0
                     For ci = 0 To 9
                        If (pattern( ci ) And scores_table( cj, ci )) = 0 Then
                           fail = 1
                           Exit For
                        EndIf
                     Next ci
                     If fail = 0 Then
                        score = score + scores_table( cj, 10 )
                        Exit Do
                     EndIf
                     cj = cj+1
                  Loop Until scores_table( cj, 0 ) < 0
               EndIf
            Next dir
            If score > high_score Then
               high_score = score
               high_x = cx
               high_y = cy
            EndIf
         EndIf
      Next cy
   Next cx
   gpx = high_x
   gpy = high_y
'Print "High Score=";high_score;" at ";gpx;",";gpy

End Sub

'--------------------------------------

' Flash the played piece a few times to call attention to it

Sub Animate_Move(x, y)

   spx=35 + x * 28
   spy=35 + y * 28
   for i = 1 to 5
      Circle spx, spy, 5, 1,, rgb(white), rgb(white)
      Pause 100
      Circle spx, spy, 5, 1,, rgb(black), rgb(black)
      Pause 100
   next i

End Sub

'--------------------------------------

' Make the inidicated move on the playing arena

Sub Set_Board(x, y, play)

   arena( x, y ) = play
   spx=35 + x * 28
   spy=35 + y * 28
   if play = HUMAN then
      Circle spx, spy, 11, 1,, rgb(white), rgb(black)
   else
      Circle spx, spy, 11, 1,, rgb(black), rgb(white)      
   endif

End Sub

'--------------------------------------

' Return true if player at x, y is a winner
' SAve the coordinates of the winning pieces
' so that the flash routine knows where they are

Function Check_Winner(x, y)

   piece = arena( x, y ) ' the piece that just moved
   pattern( 5 ) = piece
   wloc( 5, 0 ) = x
   wloc( 5, 1 ) = y
   winner(5,0) = -1 ' Marked unused
   For dir = 0 To 3
      dx = vectors( dir, 0 )
      dy = vectors( dir, 1 )
      pieces = 0
      For dist = 1 To 5
         dl = 5 - dist
         dr = 5 + dist
         xl = x - dist * dx
         yl = y - dist * dy
         xr = x + dist * dx
         yr = y + dist * dy
         If xl >= 0 And xl <= 18 And yl >= 0 And yl <= 18 Then
            pattern( dl ) = arena( xl, yl )
            wloc( dl, 0 ) = xl
            wloc( dl, 1 ) = yl
         Else
            pattern( dl ) = EMPTY
         EndIf
         If xr >= 0 And xr <= 18 And yr >= 0 And yr <= 18 Then
            pattern( dr ) = arena( xr, yr )
            wloc( dr, 0 ) = xr
            wloc( dr, 1 ) = yr
         Else
            pattern( dr ) = EMPTY
         EndIf
         pieces = pieces + pattern( dl ) + pattern( dr )
      Next dist

      ' See if pattern contains a winner

      count = 0
      win = 0
      For dist = 0 To 10
         If pattern( dist ) <> piece Then
            count = 0
         Else
            winner( count, 0 ) = wloc( dist, 0 ) ' save winning/losing coords
            winner( count, 1 ) = wloc( dist, 1 ) ' so the pieces can be highlighted
            count = count + 1
            If count = 5 Then win = 1 ' five in a row wins
            If count = 6 Then win = -1 ' but 6 in a row loses
         EndIf
      Next dist
      If win <> 0 Then
        Check_Winner = win
        Exit Function
      EndIf
   Next dir
   Check_Winner = 0

End Function

'--------------------------------------

' Display the winning message for which ever player won

Sub Display_Winner play

for k = 1 to 10
   for i = 0 to 5
      for j = 0 to 5
         if winner( i, 0 ) >= 0 then
            spx = 35 + 28 * winner( i, 0 )
            spy = 35 + 28 * winner( i, 1 )
         Endif
         Circle spx, spy, 4, 1,, rgb(white), rgb(white)
      next j
   next i
   Pause 100
   for i = 0 to 5
      for j = 0 to 5
         if winner( i, 0 ) >= 0 then
            spx = 35 + 28 * winner( i, 0 )
            spy = 35 + 28 * winner( i, 1 )
         Endif
         Circle spx, spy, 4, 1,, rgb(red), rgb(red)
      next j
   next i
   Pause 100
next k
                 
   If play = HUMAN Then
      Text 600,400,"you win",,5
   Else
      Text 600,400,"I win",,5
   EndIf
End Sub
